openapi: 3.0.1
info:
  title: Схема API для хранилища подписанных документов
  description: >
    Описывает конечные точки для проверки, сохранения подписанного документа ЭП В хранилище. 
    Так же описаны вспомогательные для этого процесса действия (конфиг для виджета, в зависимости
    от возможностей пользователя и окружения, формирование архива и визуализации документа).
  version: 1.0.1
servers:
  # - url: http://localhost:8009/app/external_api
  # Непонятно, как сделать так, чтобы тут не было списка серверов, возможно, надо сначала как то использовать .env
  - url: http://b2b-center.ru.test/eds/external_operation/v1
paths:
#  /Api/eds/sign_config:
#    post:
#      requestBody:
#        content:
#          application/json:
#            schema:
#              oneOf:
#                - $ref: '#/components/schemas/SignConfigRequest'
#                - $ref: '#/components/schemas/SignFilesConfigRequest'
#              discriminator:
#                propertyName: content_type
#                mapping:
#                  text: '#/components/schemas/SignConfigRequest'
#                  files: '#/components/schemas/SignFilesConfigRequest'
#      responses:
#        200:
#          description: Конфиг для Js с необходимыми данными для формаирования ЭП текста
#          content:
#            application/json:
#              schema:
#                oneOf:
#                  - $ref: '#/components/schemas/SignConfigResponse'
#                  - $ref: '#/components/schemas/SignFilesConfigResponse'
#                discriminator:
#                  propertyName: type
#                  mapping:
#                    text: '#/components/schemas/SignConfigResponse'
#                    files: '#/components/schemas/SignFilesConfigResponse'
  /api/eds/sign_config_text:
    post:
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SignConfigRequest'
      responses:
        200:
          description: Конфиг для Js с необходимыми данными для формаирования ЭП текста
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SignConfigResponse'
        400:
          $ref: '#/components/responses/ErrorResponse'
  /api/eds/sign_config_files:
    post:
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SignFilesConfigRequest'
      responses:
        200:
          description: Конфиг для Js с необходимыми данными для формаирования ЭП списка файлов из FileStorage
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SignFilesConfigResponse'
        400:
          $ref: '#/components/responses/ErrorResponse'
  /api/eds/signed_document_text:
    post:
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SignedTextDocumentCreateRequest'
      responses:
        200:
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SignedDocumentCreatedResponse'
        400:
          $ref: '#/components/responses/ErrorResponse'
components:
  schemas:
    Error:
      description: Описывает ошибку
      type: object
      properties:
        title:
          type: string
        description:
          type: string
        api_code:
          type: string
        trace_id:
          $ref: '#/components/schemas/TraceID'
      required: [ title, api_code ]
    FileId:
      type: integer
    UserInfo:
      type: object
      properties:
        type:
          type: string
          enum: [ bearer_in_header ]
    SignContentType:
      type: string
      enum: [ text, files ]
    TraceID:
      type: string
    SignedDocumentId:
      type: integer
    Signature:
      type: string
    SignatureType:
      type: string
      enum: [ BES, XLT1 ]
    Hash:
      type: string
    Hashes:
      type: array
      items:
        $ref: '#/components/schemas/Hash'
    FileHash:
      type: object
      properties:
        file_id:
          $ref: '#/components/schemas/FileId'
        hash:
          $ref: '#/components/schemas/Hash'
      required: [ file_id, hash ]
    FileHashList:
      type: array
      items:
        $ref: '#/components/schemas/FileHash'
    QualifiedCertificateConfigItem:
      description: Данные по зарегистрированным за пользователем сертификатам. На КЗ может быть оба вида сертификата у пользователя одновременно
      type: object
      properties:
        identifier_type:
          description: Для плагина КриптоПро используется отпечаток при поиске сертификатов в хранилище, у NCA - БИН
          type: string
          enum: [ thumbprint, bin ]
        identifier:
          type: string
        software: # можно использовать алгоритм вместо явного указания ПО
          type: string
          enum: [ CPro, NCA ]
      #          $ref: '#/components/schemas/ClientSoftware'
      #          description: Что использовать для работы с этим сертификатом - КриптоПро плагин или NCALayer в КЗ
      #          oneOf:
      required: [ identifier_type, identifier, software ]
    QualifiedSignConfig:
      type: object
      properties:
        valid:
          type: array
          items:
            $ref: '#/components/schemas/QualifiedCertificateConfigItem'
      # todo: unprocessed, blocked, outdated, links
      required: [ valid ]
    SimpleSignConfig:
      type: object
      properties:
        owner:
          type: string
        org_name:
          type: string
      required: [ owner, org_name ] # TODO: TTL, expire soon, etc
    MockQualifiedConfig:
      type: object
      properties:
        user_name:
          type: string
        owner:
          type: string # FIXME: в чем отличие имя пользователя и owner?
        org_name:
          type: string
        issuer:
          type: string
        serial_number:
          type: string
        thumbprint:
          type: string
        valid_to:
          type: string # DateTime
        valid_from:
          type: string
        algorithm:
          type: string
        certificate_body:
          type: string
      required: [ owner, issuer, serial_number, thumbprint, valid_from, valid_to ] # Проверить, чего не хватает
    MockSignConfig:
      description: Фейковые данные для заглушки (подпись, сертификат), которые необходимы, чтобы имитировать процесс формирования ЭП
      type: object
      properties:
        signature:
          $ref: '#/components/schemas/Signature'
        qualified:
          description: Фейковые данные для отображения их как данные сертификата текущего пользователя
          type: array
          items:
            $ref: '#/components/schemas/MockQualifiedConfig'
    # Requests
    SignConfigRequest:
      type: object
      properties:
        sign_content_type:
          $ref: '#/components/schemas/SignContentType'
        user_info:
          $ref: '#/components/schemas/UserInfo'
    SignFilesConfigRequest:
      allOf:
        - $ref: '#/components/schemas/SignConfigRequest'
        - type: object
          properties:
            file_ids:
              type: array
              items:
                $ref: '#/components/schemas/FileId'
    # Responses
    SignConfigResponse:
      type: object
      properties:
        type:
          type: string
          enum: [ text ]
        qualified:
          $ref: '#/components/schemas/QualifiedSignConfig'
        simple:
          $ref: '#/components/schemas/SimpleSignConfig'
        mock:
          $ref: '#/components/schemas/MockSignConfig'
      required: [ type ]
      discriminator:
        propertyName: type
        mapping:
          text: SignConfigResponse
          files: SignFilesConfigResponse
    SignFilesConfigResponse:
      allOf:
        - $ref: '#/components/schemas/SignConfigResponse'
        - type: object
          properties:
            type:
              type: string
              enum: [ files ]
            hashes:
              type: array
              items:
                type: object
                properties:
                  file_id:
                    type: integer
                  hash:
                    $ref: '#/components/schemas/Hash'
                required: [ file_id, hash ]
    SignedTextDocumentCreateRequest:
      type: object
      properties:
        content:
          type: string
        sign_content_type:
          $ref: '#/components/schemas/SignContentType'
        signature:
          $ref: '#/components/schemas/Signature'
        user_info:
          $ref: '#/components/schemas/UserInfo'
      required: [content, sign_content_type, signature, user_info]
    SignedDocumentCreatedResponse:
      type: object
      properties:
        doc_id:
          $ref: '#/components/schemas/SignedDocumentId'
  responses:
    ErrorResponse:
      description: Описывает ответ с ошибкой
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
